<?xml version="1.0" encoding="UTF-8"?>
<?xml-stylesheet href="chrome://global/skin/global.css" type="text/css"?>
<?xml-stylesheet href="chrome://cardbook/content/skin/cardbookMain.css" type="text/css"?>
<?xml-stylesheet href="chrome://cardbook/content/skin/cardbookLittleIcons.css" type="text/css"?>
<?xml-stylesheet href="chrome://cardbook/content/skin/cardbookEdition.css" type="text/css"?>
<?xml-stylesheet href="chrome://cardbook/content/skin/cardbookAddressBooks.css" type="text/css"?>
<?xml-stylesheet href="chrome://cardbook/content/skin/cardbookEmpty.css" type="text/css"?>
<!-- for the icons of the CardBook menus -->
<?xml-stylesheet href="chrome://cardbook/content/skin/cardbookMenuIcons.css" type="text/css"?>
<!-- for the small-button class -->
<?xml-stylesheet href="chrome://messenger/skin/searchDialog.css" type="text/css"?>
<!-- for the datepicker class -->
<?xml-stylesheet type="text/css" href="chrome://calendar/skin/shared/widgets/minimonth.css"?>
<?xml-stylesheet type="text/css" href="chrome://calendar/skin/shared/datetimepickers.css"?>
<!-- for the preference star -->
<?xml-stylesheet href="chrome://cardbook/content/skin/cardbookPrefStar.css" type="text/css"?>
<!-- for notificationbox.xml and the datepicker binding -->
<?xml-stylesheet href="chrome://messenger/content/bindings.css" type="text/css"?>
<?xml-stylesheet href="chrome://messenger/content/notification.css" type="text/css"?>
<!-- for the groupbox -->
<!-- <?xml-stylesheet type="text/css" href="chrome://messenger/skin/messenger.css"?> -->
<!-- for the textbox -->
<?xml-stylesheet type="text/css" href="chrome://messenger/skin/input-fields.css"?>
<!-- for the display -->
<?xml-stylesheet type="text/css" href="chrome://messenger/skin/themeableDialog.css"?>
<!-- for the tagvalue attribute -->
<?xml-stylesheet href="chrome://messenger/skin/messageHeader.css" type="text/css"?>

<window xmlns="http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul"
	xmlns:html="http://www.w3.org/1999/xhtml"
	onload="wdw_cardEdition.load();" resizable="true"
	onclose="wdw_cardEdition.cancel();"
	id="wdw_cardEdition"
	persist="screenX screenY width height sizemode" class="cardbookBackgroundColorClass dialog-content-box"
	windowtype="CardBook:contactEditionWindow"
	lightweightthemes="true"
	style="min-width:500px;min-height:600px;">
	
	<script type="application/x-javascript" src="chrome://cardbook/content/cardbookRichContext.js"/>
	<script type="application/x-javascript" src="chrome://cardbook/content/observers/cardBookObserverRepository.js"/>
	<script type="application/x-javascript" src="chrome://cardbook/content/observers/cardBookEditionObserver.js"/>
	<script type="application/x-javascript" src="chrome://cardbook/content/cardbookClipboard.js"/>
	<script type="application/x-javascript" src="chrome://cardbook/content/cardbookNotifications.js"/>
	<script type="application/x-javascript" src="chrome://cardbook/content/cardbookElementTools.js"/>
	<script type="application/x-javascript" src="chrome://cardbook/content/cardbookWindowUtils.js"/>
	<script type="application/x-javascript" src="chrome://cardbook/content/indexedDB/cardbookEncryptor.js"/>
	<script type="application/x-javascript" src="chrome://cardbook/content/indexedDB/cardbookIndexedDB.js"/>
	<script type="application/x-javascript" src="chrome://cardbook/content/indexedDB/cardbookIDBCard.js"/>
	<script type="application/x-javascript" src="chrome://cardbook/content/indexedDB/cardbookIDBCat.js"/>
	<script type="application/x-javascript" src="chrome://cardbook/content/indexedDB/cardbookIDBUndo.js"/>
	<script type="application/x-javascript" src="chrome://cardbook/content/indexedDB/cardbookIDBImage.js"/>
	<script type="application/x-javascript" src="chrome://cardbook/content/indexedDB/cardbookIDBMailPop.js"/>
	<script type="application/x-javascript" src="chrome://cardbook/content/indexedDB/cardbookIDBPrefDispName.js"/>
	<script type="application/x-javascript" src="chrome://cardbook/content/indexedDB/cardbookIDBSearch.js"/>
	<script type="application/x-javascript" src="chrome://cardbook/content/cardbookActions.js"/>
	<script type="application/x-javascript" src="chrome://cardbook/content/cardbookCardParser.js"/>
	<script type="application/x-javascript" src="chrome://cardbook/content/cardEdition/wdw_imageEdition.js"/>
	<script type="application/x-javascript" src="chrome://cardbook/content/cardEdition/wdw_templateEdition.js"/>
	<script type="application/x-javascript" src="chrome://cardbook/content/cardEdition/wdw_cardEdition.js"/>
	<script type="application/x-javascript" src="chrome://cardbook/content/cardEdition/wdw_cardEditionEvents.js"/>
	<script type="application/x-javascript" src="chrome://cardbook/content/cardEdition/wdw_cardEditionValidations.js"/>
	<script type="application/x-javascript" src="chrome://cardbook/content/scripts/i18n.js"/>
	<script type="application/x-javascript" src="chrome://cardbook/content/enigmail/cardbookEnigmail.js"/>
	
	<!-- for the datepicker class -->
	<script type="application/x-javascript" src="chrome://calendar/content/calendar-ui-utils.js"/>
	<script type="application/x-javascript" src="chrome://cardbook/content/cardbookDatePicker.js"/>
	<script type="application/x-javascript" src="chrome://messenger/content/customElements.js"/>
	<script type="application/x-javascript" src="chrome://calendar/content/widgets/calendar-minimonth.js"/>
	<!-- for the textbox -->
	<script type="application/x-javascript" src="chrome://global/content/globalOverlay.js"/>
	<script type="application/x-javascript" src="chrome://global/content/editMenuOverlay.js"/>

	<keyset id="wdw_cardEdition-keys">
		<key id="returnKey" keycode="VK_RETURN" oncommand="wdw_cardEdition.returnKey();"/>
		<key id="escapeKey" keycode="VK_ESCAPE" oncommand="wdw_cardEdition.cancel();" />
	</keyset>

	<menupopup id="imageCardContextMenu" onpopupshowing="wdw_imageEdition.imageCardContextShowing();">
		<menuitem id="addImageCardFromFile" label="__MSG_addImageCardFromFileLabel__" oncommand="wdw_imageEdition.addImageCardFromFile();"/>
		<menuitem id="pasteImageCard" label="__MSG_pasteImageCardLabel__" oncommand="wdw_imageEdition.pasteImageCard();"/>
		<menuitem id="saveImageCard" label="__MSG_saveImageCardLabel__" oncommand="wdw_imageEdition.saveImageCard();"/>
		<menuitem id="copyImageCard" label="__MSG_copyImageCardLabel__" oncommand="wdw_imageEdition.copyImageCard();"/>
		<menuitem id="deleteImageCard" label="__MSG_deleteImageCardLabel__" oncommand="wdw_imageEdition.deleteImageCard();"/>
	</menupopup>

	<menupopup id="availableCardsTreeContextMenu" onpopupshowing="return wdw_cardEdition.availableCardsTreeContextShowing(event);">
		<menuitem id="appendlistavailableCardsTreeMenu" label="__MSG_appendContactLabel__" oncommand="wdw_cardEdition.modifyLists(this);"/>
	</menupopup>

	<menupopup id="addedCardsTreeContextMenu" onpopupshowing="return cardbookWindowUtils.displayColumnsPicker(event);">
		<menuitem id="deletelistaddedCardsTreeMenu" label="__MSG_deletelistTreeLabel__" oncommand="wdw_cardEdition.modifyLists(this);"/>
	</menupopup>

	<vbox id="rightPaneDownHbox2" flex="1">
		<vbox>
			<hbox id="cardbookContactButtonsBox">
				<button id="generalTab" label="__MSG_generalTabLabel__" class="cardbookContactButtons" oncommand="wdw_cardEdition.showPane('generalTabPanel');"/>
				<button id="noteTab" label="__MSG_noteTabLabel__" class="cardbookContactButtons" oncommand="wdw_cardEdition.showPane('noteTabPanel');"/>
				<button id="listTab" label="__MSG_listsTabLabel__" class="cardbookContactButtons" oncommand="wdw_cardEdition.showPane('listTabPanel');"/>
				<button id="keyTab" label="__MSG_keyTabLabel__" class="cardbookContactButtons" oncommand="wdw_cardEdition.showPane('keyTabPanel');"/>
				<button id="helpTab" label="__MSG_helpTabLabel__" class="cardbookContactButtons" oncommand="wdw_cardEdition.showPane('helpTabPanel');"/>
			</hbox>
		</vbox>

		<vbox id="generalTabPanel" class="cardbookTab" style="overflow:auto;" flex="1">	
			<hbox>
				<vbox flex="1">
					<hbox flex="1">
						<vbox flex="1">
							<vbox id="addressbookMenulistReadOnlyGroupbox">
								<label id="addressbookHeader" class="header"/>
								<hbox flex="1" class="input-container">
									<html:input id="addressbookTextBox" style="min-height:36px;" readonly="true" class="indent"/>
								</hbox>
							</vbox>
							<vbox id="addressbookMenulistReadWriteGroupbox" flex="1">
								<label id="addressbookMenulistLabel" class="header"/>
								<hbox align="center" flex="1" style="min-height:36px;">
									<menulist id="addressbookMenulist" flex="1" oncommand="wdw_cardEdition.changeAddressbook();">
										<menupopup id="addressbookMenupopup" flex="1"/>
									</menulist>
								</hbox>
							</vbox>
							<vbox id="categoriesmodernGroupbox">
								<label id="categoriesLabel" class="header">__MSG_categoriesHeader__</label>
								<hbox id="categoriesmodernHbox" flex="1" class="indent">
									<vbox id="categoriesmodernRow"/>
								</hbox>
							</vbox>
							<vbox id="categoriesReadWriteGroupbox" flex="1">
								<label class="header">__MSG_categoriesHeader__</label>
								<hbox align="center" flex="1" style="min-height:36px;">
									<menulist id="categoriesMenulist" flex="1" onkeydown="cardbookWindowUtils.panelMenulistKeydown(event, 'category', 'categoriesMenupopup');">
										<menupopup id="categoriesMenupopup"
											onpopuphiding="return cardbookWindowUtils.panelMenupopupHiding(event, 'category', this.id);" ignorekeys="true">
											<html:input id="categoriesTextbox"
												placeholder="__MSG_categoriesTextboxLabel__"
												onkeydown="cardbookWindowUtils.panelTextboxKeydown(event, 'category', 'categoriesMenupopup');"/>
											<menuseparator/>
										</menupopup>
									</menulist>
								</hbox>
							</vbox>
							<vbox id="existingDataGroupbox" flex="1">
								<label class="header">__MSG_existingDataGroupboxLabel__</label>
								<hbox align="center" flex="1">
									<menulist id="contactMenulist" flex="1" oncommand="wdw_cardEdition.changeContact();">
										<menupopup id="contactMenupopup" flex="1" onpopupshowing="wdw_cardEdition.loadContacts();"/>
									</menulist>
								</hbox>
							</vbox>
						</vbox>
					</hbox>
				</vbox>
				<vbox align="center" width="150px">
					<hbox id="imageBox" align="center" height="150px">
						<html:img id="imageForSizing" hidden="true"/>
						<image id="defaultCardImage" context="imageCardContextMenu" style="max-height: 150px; max-width: 150px;"
							ondblclick="wdw_imageEdition.addImageCardFromFile();" 
							ondrop="wdw_imageEdition.dragImageCard(event);"
							ondragenter="wdw_imageEdition.checkDragImageCard(event);"
							ondragover="wdw_imageEdition.checkDragImageCard(event);"/>
					</hbox>
				</vbox>
			</hbox>
			<vbox id="fnGroupbox">
				<label id="fnLabel" class="header">__MSG_fnLabel__</label>
				<hbox flex="1" class="input-container">
					<button type="checkbox" id="autoComputeFnButton" class="cardbookProcessFnClass" oncommand="wdw_cardEdition.autoComputeFn(this);"/>
					<html:input id="fnTextBox" flex="1"/>
					<checkbox id="preferDisplayNameCheckBox" label="__MSG_preferDisplayNameCheckBoxLabel__" oncommand="wdw_cardEdition.savePreferDisplayName();"/>
				</hbox>
			</vbox>
			<hbox>
				<vbox id="personalGroupbox" flex="1">
					<hbox align="center">
						<button type="checkbox" id="expandPersonalImage" class="cardbookExpandedClass" expanded="true" oncommand="wdw_cardEdition.expandButton(this);"/>
						<label class="header">__MSG_persTitleLabel__</label>
					</hbox>
					<html:table id="personalTable">
						<html:tr id="lastnameRow">
							<html:td>
								<label id="lastnameLabel" value="__MSG_lastnameLabel__" control="lastnameTextBox" class="header"/>
							</html:td>
							<html:td>
								<hbox flex="1" align="center">
									<html:input id="lastnameTextBox" data-field-name="lastname" oninput="wdw_cardEdition.onInputField(event);"/>
									<button type="checkbox" id="cardbookSwitchButtonDown" class="cardbookSwitchButtonDownClass" tooltiptext="__MSG_cardbookSwitchButtonTooltip__" oncommand="wdw_cardEdition.switchLastnameAndFirstname();"/>
									<button type="checkbox" id="lastnameProcessButton" class="cardbookProcessClass" autoConvertField="true" oncommand="wdw_cardEdition.setConvertFunction(event);"/>
								</hbox>
							</html:td>
						</html:tr>
						<html:tr id="firstnameRow">
							<html:td>
								<label id="firstnameLabel" value="__MSG_firstnameLabel__" control="firstnameTextBox" class="header"/>
							</html:td>
							<html:td>
								<hbox flex="1" align="center">
									<html:input id="firstnameTextBox" data-field-name="firstname" oninput="wdw_cardEdition.onInputField(event);"/>
									<button type="checkbox" id="cardbookSwitchButtonUp" class="cardbookSwitchButtonUpClass" tooltiptext="__MSG_cardbookSwitchButtonTooltip__" oncommand="wdw_cardEdition.switchLastnameAndFirstname();"/>
									<button type="checkbox" id="firstnameProcessButton" class="cardbookProcessClass" autoConvertField="true" oncommand="wdw_cardEdition.setConvertFunction(event);"/>
								</hbox>
							</html:td>
						</html:tr>
						<html:tr id="othernameRow">
							<html:td>
								<label id="othernameLabel" value="__MSG_othernameLabel__" control="othernameTextBox" class="header"/>
							</html:td>
							<html:td>
								<html:input id="othernameTextBox" data-field-name="othername" oninput="wdw_cardEdition.onInputField(event);"/>
								<button type="checkbox" id="othernameProcessButton" class="cardbookProcessClass" autoConvertField="true" oncommand="wdw_cardEdition.setConvertFunction(event);"/>
							</html:td>
						</html:tr>
						<html:tr id="prefixnameRow">
							<html:td>
								<label id="prefixnameLabel" value="__MSG_prefixnameLabel__" control="prefixnameTextBox" class="header"/>
							</html:td>
							<html:td>
								<html:input id="prefixnameTextBox" data-field-name="prefixname" oninput="wdw_cardEdition.onInputField(event);"/>
								<button type="checkbox" id="prefixnameProcessButton" class="cardbookProcessClass" autoConvertField="true" oncommand="wdw_cardEdition.setConvertFunction(event);"/>
							</html:td>
						</html:tr>
						<html:tr id="suffixnameRow">
							<html:td>
								<label id="suffixnameLabel" value="__MSG_suffixnameLabel__" control="suffixnameTextBox" class="header"/>
							</html:td>
							<html:td>
								<html:input id="suffixnameTextBox" data-field-name="suffixname" oninput="wdw_cardEdition.onInputField(event);"/>
								<button type="checkbox" id="suffixnameProcessButton" class="cardbookProcessClass" autoConvertField="true" oncommand="wdw_cardEdition.setConvertFunction(event);"/>
							</html:td>
						</html:tr>
						<html:tr id="nicknameRow">
							<html:td>
								<label id="nicknameLabel" value="__MSG_nicknameLabel__" control="nicknameTextBox" class="header"/>
							</html:td>
							<html:td>
								<html:input id="nicknameTextBox" data-field-name="nickname" oninput="wdw_cardEdition.onInputField(event);"/>
								<button type="checkbox" id="nicknameProcessButton" class="cardbookProcessClass" autoConvertField="true" oncommand="wdw_cardEdition.setConvertFunction(event);"/>
							</html:td>
						</html:tr>
						<html:tr id="genderRow1">
							<html:td>
								<label id="genderLabel1" value="__MSG_genderLabel__" control="genderMenulist" class="header"/>
							</html:td>
							<html:td>
								<hbox align="center" style="min-height:36px;">
									<menulist id="genderMenulist">
										<menupopup id="genderMenupopup"/>
									</menulist>
								</hbox>
							</html:td>
						</html:tr>
						<html:tr id="genderRow2">
							<html:td>
								<label id="genderLabel2" value="__MSG_genderLabel__" control="genderTextBox" class="header"/>
							</html:td>
							<html:td>
								<html:input id="genderTextBox"/>
							</html:td>
						</html:tr>
						<html:tr id="bdayRow1">
							<html:td>
								<label id="bdayDatepickerLabel" value="__MSG_bdayLabel__" control="bdayDatepicker" class="header"/>
							</html:td>
							<html:td>
								<cardbookdatepicker id="bdayDatepicker" oninput="wdw_cardEdition.unsetWrongValidation();"/>
							</html:td>
						</html:tr>
						<html:tr id="bdayRow2">
							<html:td>
								<label id="bdayLabel" value="__MSG_bdayLabel__" control="bdayTextBox" class="header"/>
							</html:td>
							<html:td>
								<html:input id="bdayTextBox"/>
							</html:td>
						</html:tr>
						<html:tr id="birthplaceRow">
							<html:td>
								<label id="birthplaceLabel" value="__MSG_birthplaceLabel__" control="birthplaceTextBox" class="header"/>
							</html:td>
							<html:td>
								<html:input id="birthplaceTextBox" data-field-name="birthplace" oninput="wdw_cardEdition.onInputField(event);"/>
								<button type="checkbox" id="birthplaceProcessButton" class="cardbookProcessClass" autoConvertField="true" oncommand="wdw_cardEdition.setConvertFunction(event);"/>
							</html:td>
						</html:tr>
						<html:tr id="deathdateRow1">
							<html:td>
								<label id="deathdateDatepickerLabel" value="__MSG_deathdateLabel__" control="deathdateDatepicker" class="header"/>
							</html:td>
							<html:td>
								<cardbookdatepicker id="deathdateDatepicker" oninput="wdw_cardEdition.unsetWrongValidation();"/>
							</html:td>
						</html:tr>
						<html:tr id="deathdateRow2">
							<html:td>
								<label id="deathdateLabel" value="__MSG_deathdateLabel__" control="deathdateTextBox" class="header"/>
							</html:td>
							<html:td>
								<html:input id="deathdateTextBox"/>
							</html:td>
						</html:tr>
						<html:tr id="deathplaceRow">
							<html:td>
								<label id="deathplaceLabel" value="__MSG_deathplaceLabel__" control="deathplaceTextBox" class="header"/>
							</html:td>
							<html:td>
								<html:input id="deathplaceTextBox" data-field-name="deathplace" oninput="wdw_cardEdition.onInputField(event);"/>
								<button type="checkbox" id="deathplaceProcessButton" class="cardbookProcessClass" autoConvertField="true" oncommand="wdw_cardEdition.setConvertFunction(event);"/>
							</html:td>
						</html:tr>
						<html:tr id="anniversaryRow1">
							<html:td>
								<label id="anniversaryDatepickerLabel" value="__MSG_anniversaryLabel__" control="anniversaryDatepicker" class="header"/>
							</html:td>
							<html:td>
								<cardbookdatepicker id="anniversaryDatepicker" oninput="wdw_cardEdition.unsetWrongValidation();"/>
							</html:td>
						</html:tr>
						<html:tr id="anniversaryRow2">
							<html:td>
								<label id="anniversaryLabel" value="__MSG_anniversaryLabel__" control="anniversaryTextBox" class="header"/>
							</html:td>
							<html:td>
								<html:input id="anniversaryTextBox"/>
							</html:td>
						</html:tr>
						<html:tr hidden="true">
							<html:td>
								<html:textarea id="othersTextBox"/>
							</html:td>
						</html:tr>
						<html:tr hidden="true">
							<html:td>
								<html:input id="photoExtensionTextBox"/>
								<html:input id="photoURITextBox"/>
								<html:input id="photoAttachmentIdTextBox"/>
							</html:td>
						</html:tr>
						<html:tr hidden="true">
							<html:td>
								<html:input id="logoExtensionTextBox"/>
								<html:input id="logoURITextBox"/>
							</html:td>
						</html:tr>
						<html:tr hidden="true">
							<html:td>
								<html:input id="soundExtensionTextBox"/>
								<html:input id="soundURITextBox"/>
							</html:td>
						</html:tr>
						<html:tr hidden="true">
							<html:td>
								<html:input id="dirPrefIdTextBox"/>
							</html:td>
						</html:tr>
						<html:tr hidden="true">
							<html:td>
								<html:input id="uidTextBox"/>
							</html:td>
						</html:tr>
						<html:tr hidden="true">
							<html:td>
								<html:input id="versionTextBox"/>
							</html:td>
						</html:tr>
					</html:table>
				</vbox>
				<vbox id="orgGroupbox" flex="1">
					<hbox align="center">
						<button type="checkbox" id="expandOrgImage" class="cardbookExpandedClass" expanded="true" oncommand="wdw_cardEdition.expandButton(this);"/>
						<label class="header">__MSG_orgTitleLabel__</label>
					</hbox>
					<html:table id="orgTable"/>
				</vbox>
			</hbox>
			<vbox id="contactGroupbox" flex="1">
				<vbox id="classicalRows" flex="1"/>
				<vbox id="modernRows" flex="1"/>
				<vbox id="readWriteTypesVbox" flex="1">
					<vbox id="emailGroupbox" flex="1"/>
					<vbox id="telGroupbox" flex="1"/>
					<vbox id="adrGroupbox" flex="1"/>
					<vbox id="imppGroupbox" flex="1"/>
					<vbox id="urlGroupbox" flex="1"/>
					<vbox id="eventGroupbox" flex="1"/>
					<vbox id="tzGroupbox" flex="1"/>
				</vbox>
				<panel id="adrPanel">
					<vbox flex="1">
						<hbox flex="1">
							<vbox flex="1">
								<html:table>
									<html:tr id="postOfficeRow">
										<html:td>
											<label value="__MSG_postOfficeLabel__" control="postOfficeTextBox" class="header"/>
										</html:td>
										<html:td>
											<html:input id="postOfficeTextBox" data-field-name="postOffice" placeholder="__MSG_deprecatedLabel__" oninput="wdw_cardEdition.onInputField(event);"/>
											<button type="checkbox" id="postOfficeProcessButton" class="cardbookProcessClass" autoConvertField="true" oncommand="wdw_cardEdition.setConvertFunction(event);"/>
										</html:td>
									</html:tr>
									<html:tr id="extendedAddrRow">
										<html:td>
											<label value="__MSG_extendedAddrLabel__" control="extendedAddrTextBox" class="header"/>
										</html:td>
										<html:td>
											<html:input id="extendedAddrTextBox" data-field-name="extendedAddr" placeholder="__MSG_deprecatedLabel__" oninput="wdw_cardEdition.onInputField(event);"/>
											<button type="checkbox" id="extendedAddrProcessButton" class="cardbookProcessClass" autoConvertField="true" oncommand="wdw_cardEdition.setConvertFunction(event);"/>
										</html:td>
									</html:tr>
									<html:tr id="streetRow">
										<html:td>
											<label value="__MSG_streetLabel__" control="streetTextBox" class="header"/>
										</html:td>
										<html:td>
											<html:textarea id="streetTextBox" data-field-name="street" oninput="wdw_cardEdition.onInputField(event);"/>
											<button type="checkbox" id="streetProcessButton" class="cardbookProcessClass" autoConvertField="true" oncommand="wdw_cardEdition.setConvertFunction(event);"/>
										</html:td>
									</html:tr>
									<html:tr id="localityRow">
										<html:td>
											<label value="__MSG_localityLabel__" control="localityTextBox" class="header"/>
										</html:td>
										<html:td>
											<html:input id="localityTextBox" data-field-name="locality" type="autocomplete" autocompletesearch="form-history" autocompletesearchparam="localityTextBox" class="padded" oninput="wdw_cardEdition.onInputField(event);"/>
											<button type="checkbox" id="localityProcessButton" class="cardbookProcessClass" autoConvertField="true" oncommand="wdw_cardEdition.setConvertFunction(event);"/>
										</html:td>
									</html:tr>
									<html:tr id="regionRow">
										<html:td>
											<label value="__MSG_regionLabel__" control="regionTextBox" class="header"/>
										</html:td>
										<html:td>
											<html:input id="regionTextBox" data-field-name="region" type="autocomplete" autocompletesearch="form-history" autocompletesearchparam="regionTextBox" class="padded" oninput="wdw_cardEdition.onInputField(event);"/>
											<button type="checkbox" id="regionProcessButton" class="cardbookProcessClass" autoConvertField="true" oncommand="wdw_cardEdition.setConvertFunction(event);"/>
										</html:td>
									</html:tr>
									<html:tr id="postalCodeRow">
										<html:td>
											<label value="__MSG_postalCodeLabel__" control="postalCodeTextBox" class="header"/>
										</html:td>
										<html:td>
											<html:input id="postalCodeTextBox" data-field-name="postalCode" type="autocomplete" autocompletesearch="form-history" autocompletesearchparam="postalCodeTextBox" class="padded" oninput="wdw_cardEdition.onInputField(event);"/>
											<button type="checkbox" id="postalCodeProcessButton" class="cardbookProcessClass" autoConvertField="true" oncommand="wdw_cardEdition.setConvertFunction(event);"/>
										</html:td>
									</html:tr>
									<html:tr id="countryRow">
										<html:td>
											<label value="__MSG_countryLabel__" control="countryMenulist" class="header"/>
										</html:td>
										<html:td>
											<menulist id="countryMenulist" is="menulist-editable" editable="true">
												<menupopup id="countryMenupopup"/>
											</menulist>
										</html:td>
									</html:tr>
								</html:table>
							</vbox>
						</hbox>
						<hbox>
							<spacer flex="1"/>
							<button id="validateEditionLabel" label="__MSG_validateEditionLabel__" accesskey="__MSG_validateEditionAccesskey__" oncommand="cardbookWindowUtils.closeAdrPanel();"/>
						</hbox>
					</vbox>
				</panel>
			</vbox>
			<vbox id="listGroupbox" flex="1">
				<vbox id="listReadOnlyGroupbox" flex="1">
					<vbox id="addedCardsGroupbox" flex="1"/>
				</vbox>
				<vbox id="listReadWriteGroupbox" flex="1">
					<hbox align="center" hidden="true">
						<label value="__MSG_kind.edit.label__" accesskey="__MSG_kind.edit.accesskey__" control="kindTextBox" class="header"/>
						<html:input id="kindTextBox"/>
					</hbox>
					<hbox flex="1">
						<vbox flex="1">
							<vbox id="addEmailGroupbox">
								<label class="header">__MSG_addEmailGroupboxLabel__</label>
								<html:input id="addEmailInput"/>
							</vbox>
							<vbox id="availableCardsGroupbox" flex="1">
								<label class="header">__MSG_availableCardsGroupboxLabel__</label>
								<vbox>
									<search-textbox id="searchAvailableCardsInput"
										class="searchBox"
										flex="1"
										oncommand="wdw_cardEdition.searchAvailableCards(null);"/>
								</vbox>
								<hbox flex="1" ondragover="event.preventDefault();" ondrop="wdw_cardEdition.dragCards(event, 'availableCardsTree');">
									<tree id="availableCardsTree" context="availableCardsTreeContextMenu" class="cardbookTreeClass cardbookAccountTreeClass" flex="1" enableColumnDrag="true"
										hidecolumnpicker="false" persist="height sortDirection sortResource" sortDirection="ascending" sortResource="availableCardsTreeName"
										onclick="wdw_cardEdition.sortTrees(event, 'availableCardsTree');">
										<treecols id="availableCardsTreeCols">
											<treecol id="availableCardsTreeName" label="__MSG_nameLabel__" flex="1" persist="width ordinal hidden" style="text-align:left" sortDirection="ascending" closemenu="none"/>
											<splitter class="tree-splitter"/>
											<treecol id="availableCardsTreeUid" label="__MSG_uidLabel__" flex="1" persist="width ordinal hidden" hidden="true" style="text-align:left" sortDirection="ascending" closemenu="none"/>
											<splitter class="tree-splitter"/>
											<treecol id="availableCardsTreeFn" label="__MSG_fnLabel__" flex="1" persist="width ordinal hidden" hidden="true" style="text-align:left" sortDirection="ascending" closemenu="none"/>
											<splitter class="tree-splitter"/>
											<treecol id="availableCardsTreeLastname" label="__MSG_lastnameLabel__" flex="1" persist="width ordinal hidden" hidden="true" style="text-align:left" sortDirection="ascending" closemenu="none"/>
											<splitter class="tree-splitter"/>
											<treecol id="availableCardsTreeFirstname" label="__MSG_firstnameLabel__" flex="1" persist="width ordinal hidden" hidden="true" style="text-align:left" sortDirection="ascending" closemenu="none"/>
										</treecols>
										<treechildren id="availableCardsTreeChildren" ondblclick="wdw_cardEdition.modifyLists(this);" ondragstart="wdw_cardEdition.startDrag(event, this);"/>
									</tree>
								</hbox>
							</vbox>
						</vbox>
						<vbox flex="1" align="center">
							<hbox flex="1" align="center">
								<vbox flex="1" align="center">
									<button id="appendCardButton" label="__MSG_buttonAppendToListLabel__"
										oncommand="wdw_cardEdition.modifyLists(this);"/>
									<button id="appendCardEmailsButton" label="__MSG_buttonAppendEmailsToListLabel__"
										oncommand="wdw_cardEdition.modifyLists(this);"/>
									<button id="deleteListButton" label="__MSG_buttonRemoveFromListLabel__"
										oncommand="wdw_cardEdition.modifyLists(this);"/>
								</vbox>
							</hbox>
						</vbox>
						<vbox flex="1">
							<label class="header">__MSG_addedCardsGroupboxLabel__</label>
							<hbox flex="1" ondragover="event.preventDefault();" ondrop="wdw_cardEdition.dragCards(event, 'addedCardsTree');">
								<tree id="addedCardsTree" context="addedCardsTreeContextMenu" class="cardbookTreeClass cardbookAccountTreeClass" flex="1" enableColumnDrag="true"
									hidecolumnpicker="false" persist="height sortDirection sortResource" sortDirection="ascending" sortResource="addedCardsTreeName"
									onclick="wdw_cardEdition.sortTrees(event, 'addedCardsTree');">
									<treecols id="addedCardsTreeCols">
										<treecol id="addedCardsTreeName" label="__MSG_nameOrEmailLabel__" flex="1" persist="width ordinal hidden" style="text-align:left" sortDirection="ascending" closemenu="none"/>
										<splitter class="tree-splitter"/>
										<treecol id="addedCardsTreeUid" label="__MSG_uidLabel__" flex="1" persist="width ordinal hidden" hidden="true" style="text-align:left" sortDirection="ascending" closemenu="none"/>
										<splitter class="tree-splitter"/>
										<treecol id="addedCardsTreeFn" label="__MSG_fnLabel__" flex="1" persist="width ordinal hidden" hidden="true" style="text-align:left" sortDirection="ascending" closemenu="none"/>
										<splitter class="tree-splitter"/>
										<treecol id="addedCardsTreeLastname" label="__MSG_lastnameLabel__" flex="1" persist="width ordinal hidden" hidden="true" style="text-align:left" sortDirection="ascending" closemenu="none"/>
										<splitter class="tree-splitter"/>
										<treecol id="addedCardsTreeFirstname" label="__MSG_firstnameLabel__" flex="1" persist="width ordinal hidden" hidden="true" style="text-align:left" sortDirection="ascending" closemenu="none"/>
									</treecols>
									<treechildren id="addedCardsTreeChildren" ondblclick="wdw_cardEdition.modifyLists(this);" ondragstart="wdw_cardEdition.startDrag(event, this);"/>
								</tree>
							</hbox>
						</vbox>
					</hbox>
				</vbox>
			</vbox>
			<spacer id="firstTabSpacer" flex="100"/>
		</vbox>

		<vbox id="noteTabPanel" class="cardbookTab" style="overflow:auto;" flex="1">	
			<hbox id="noteGroupbox" flex="1">
				<html:textarea id="noteTextBox"/>
			</hbox>
		</vbox>

		<vbox id="listTabPanel" class="cardbookTab" style="overflow:auto;" flex="1">	
			<vbox id="PreferMailFormatReadWriteGroupbox">
				<label class="header">__MSG_PreferMailFormatGroupbox.label__</label>
				<hbox align="center" class="indent">
					<label control="PreferMailFormatPopup" value="__MSG_PreferMailFormat.label__" accesskey="__MSG_PreferMailFormat.accesskey__"/>
					<menulist id="PreferMailFormatPopup" sizetopopup="always">
						<menupopup>
							<menuitem value="0" label="__MSG_Unknown.label__"/>
							<menuitem value="1" label="__MSG_PlainText.label__"/>
							<menuitem value="2" label="__MSG_HTML.label__"/>
						</menupopup>
					</menulist>
				</hbox>
			</vbox>
			<vbox id="PreferMailFormatReadOnlyGroupbox">
				<label class="header">__MSG_PreferMailFormatGroupbox.label__</label>
				<hbox align="center" class="indent input-container">
					<label control="PreferMailFormatTextbox" value="__MSG_PreferMailFormat.label__"/>
					<html:input id="PreferMailFormatTextbox" style="min-height:36px;" readonly="true"/>
				</hbox>
			</vbox>
			<vbox id="emailpropertyGroupbox"/>
			<spacer flex="100"/>
		</vbox>

		<vbox id="keyTabPanel" class="cardbookTab" style="overflow:auto;" flex="1">	
			<vbox id="keyReadWriteToolsVbox" align="center" flex="1">
				<hbox align="center" flex="1">
					<button id="searchForOnlineKeyEditButton" tooltiptext="__MSG_searchForOnlineKeyEditButton.tooltip__" onclick="wdw_cardEdition.searchForOnlineKeyEdit();"/>
					<button id="searchForThKeyEditButton" tooltiptext="__MSG_searchForThKeyEditButton.tooltip__" onclick="wdw_cardEdition.searchForThKeyEdit();"/>
					<button id="searchForLocalKeyEditButton" tooltiptext="__MSG_searchForLocalKeyEditButton.tooltip__" onclick="wdw_cardEdition.searchForLocalKeyEdit();"/>
				</hbox>
			</vbox>
			<hbox id="keyReadWriteHbox" flex="1">
				<vbox id="keyReadWriteGroupbox" flex="1"/>
			</hbox>
			<hbox id="keyReadOnlyHbox">
				<vbox id="keyReadOnlyGroupbox"/>
			</hbox>
			<spacer id="keyTabSpacer" flex="100"/>
		</vbox>

		<vbox id="helpTabPanel" class="cardbookTab" style="overflow:auto;" flex="1">	
			<vbox flex="1">
				<hbox flex="1">
					<label><html:h2>__MSG_definitionLabel__</html:h2></label>
				</hbox>
				<label class="indent">__MSG_templateFormulaExplanation__</label>
			</vbox>
			<separator class="thin"/>
			<vbox flex="1">
				<hbox flex="1">
					<label><html:h2>__MSG_fieldsLabel__</html:h2></label>
				</hbox>
				<hbox flex="1">
					<vbox class="indent" flex="1">
						<html:table id="formulaSampleTable">
							<html:tr>
								<html:td>
									<label id="formulaMemberLabel1"/>
								</html:td>
							</html:tr>
							<html:tr>
								<html:td>
									<label id="formulaMemberLabel2"/>
								</html:td>
							</html:tr>
							<html:tr>
								<html:td>
									<label id="formulaMemberLabel3"/>
								</html:td>
							</html:tr>
							<html:tr>
								<html:td>
									<label id="formulaMemberLabel4"/>
								</html:td>
							</html:tr>
							<html:tr>
								<html:td>
									<label id="formulaMemberLabel5"/>
								</html:td>
							</html:tr>
							<html:tr>
								<html:td>
									<label id="formulaMemberLabel6"/>
								</html:td>
							</html:tr>
						</html:table>
					</vbox>
				</hbox>
			</vbox>
			<separator class="thin"/>
			<vbox flex="1">
				<hbox flex="1">
					<label><html:h2>__MSG_formulasLabel__</html:h2></label>
				</hbox>
				<label class="indent">__MSG_formulaExplanation1__</label>
				<label class="indent">__MSG_formulaExplanation2__</label>
				<label class="indent">__MSG_formulaExplanation3__</label>
				<label class="indent">__MSG_formulaExplanation4__</label>
				<label class="indent">__MSG_formulaExplanation5__</label>
				<label class="indent">__MSG_formulaExplanation6__</label>
			</vbox>
			<spacer id="helpTabSpacer" flex="100"/>
		</vbox>
	</vbox>

	<hbox>
		<vbox id="errorNotificationsHbox" class="notification-inline">
			<!-- notificationbox will be added here lazily. -->
		</vbox>
		<button id="createTemplateButton" tooltiptext="__MSG_createTemplateLabel__" oncommand="wdw_templateEdition.createTemplate();"/>
		<button id="openTemplateButton" tooltiptext="__MSG_loadTemplateLabel__" oncommand="wdw_templateEdition.loadTemplate();"/>
		<button id="applyTemplateButton" tooltiptext="__MSG_applyTemplateLabel__" oncommand="wdw_templateEdition.applyTemplate();"/>
		<spacer flex="1"/>
		<button id="previousEditButton" tooltiptext="__MSG_previousEditButton.tooltip__" oncommand="wdw_cardEdition.changeContactFromOrder('previous');"/>
		<button id="nextEditButton" tooltiptext="__MSG_nextEditButton.tooltip__" oncommand="wdw_cardEdition.changeContactFromOrder('next');"/>
		<menulist id="fieldsMenulist" flex="1">
			<menupopup id="fieldsMenupopup"
				onpopuphiding="wdw_cardEdition.changeEditionFields();return event.explicitOriginalTarget.localName != 'menuitem'" ignorekeys="true">
			</menupopup>
		</menulist>

		<button id="createEditionLabel" label="__MSG_createEditionLabel__" accesskey="__MSG_createEditionAccesskey__" oncommand="wdw_cardEdition.create();"/>
		<button id="createAndReplaceEditionLabel" label="__MSG_createAndReplaceEditionLabel__" accesskey="__MSG_createAndReplaceEditionAccesskey__" oncommand="wdw_cardEdition.createAndReplace();"/>
		<button id="saveEditionLabel" label="__MSG_saveEditionLabel__" accesskey="__MSG_saveEditionAccesskey__" oncommand="wdw_cardEdition.save();"/>
		<button id="cancelEditionLabel" label="__MSG_cancelEditionLabel__" accesskey="__MSG_cancelEditionAccesskey__" oncommand="wdw_cardEdition.cancel();"/>
	</hbox>
</window>
